Package icyllis.arc3d.core

# Class ColorSpace

java.lang.Object
icyllis.arc3d.core.ColorSpace

Direct Known Subclasses:
  `ColorSpace.Rgb`

public abstract class ColorSpace extends Object

A `ColorSpace` is used to identify a specific organization of colors. Each color space is characterized by a `color model` that defines how a color value is represented (for instance the `RGB` color model defines a color value as a triplet of numbers).

Each component of a color must fall within a valid range, specific to each color space, defined by `getMinValue(int)` and `getMaxValue(int)` This range is commonly \([0..1]\). While it is recommended to use values in the valid range, a color space always clamps input and output values when performing operations such as converting to a different color space.

### Using color spaces

This implementation provides a pre-defined set of common color spaces described in the `ColorSpace.Named` enum. To obtain an instance of one of the pre-defined color spaces, simply invoke `get(Named)`:

     ColorSpace sRgb = ColorSpace.get(ColorSpace.Named.SRGB);

The `get(Named)` method always returns the same instance for a given name. Color spaces with an `RGB` color model can be safely cast to `ColorSpace.Rgb`. Doing so gives you access to more APIs to query various properties of RGB color models: color gamut primaries, transfer functions, conversions to and from linear space, etc. Please refer to `ColorSpace.Rgb` for more information.

The documentation of `ColorSpace.Named` provides a detailed description of the various characteristics of each available color space.

### Color space conversions

To allow conversion between color spaces, this implementation uses the CIE XYZ profile connection space (PCS). Color values can be converted to and from this PCS using `toXyz(float[])` and `fromXyz(float[])`.

For color space with a non-RGB color model, the white point of the PCS must be the CIE standard illuminant D50. RGB color spaces use their native white point (D65 for `sRGB` for instance and must undergo `chromatic adaptation` as necessary.

Since the white point of the PCS is not defined for RGB color space, it is highly recommended to use the variants of the `connect(ColorSpace, ColorSpace)` method to perform conversions between color spaces. A color space can be manually adapted to a specific white point using `adapt(ColorSpace, float[])`. Please refer to the documentation of `RGB color spaces` for more information. Several common CIE standard illuminants are provided in this class as reference (see `ILLUMINANT_D65` or `ILLUMINANT_D50` for instance).

Here is an example of how to convert from a color space to another:

     // Convert from DCI-P3 to Rec.2020
     ColorSpace.Connector connector = ColorSpace.connect(
             ColorSpace.get(ColorSpace.Named.DCI_P3),
             ColorSpace.get(ColorSpace.Named.BT2020));

     float[] bt2020 = connector.transform(p3r, p3g, p3b);

You can easily convert to `sRGB` by omitting the second parameter:

     // Convert from DCI-P3 to sRGB
     ColorSpace.Connector connector = ColorSpace.connect(ColorSpace.get(ColorSpace.Named.DCI_P3));

     float[] sRGB = connector.transform(p3r, p3g, p3b);

Conversions also work between color spaces with different color models:

     // Convert from CIE L*a*b* (color model Lab) to Rec.709 (color model RGB)
     ColorSpace.Connector connector = ColorSpace.connect(
             ColorSpace.get(ColorSpace.Named.CIE_LAB),
             ColorSpace.get(ColorSpace.Named.BT709));

### Color spaces and multi-threading

Color spaces and other related classes (`ColorSpace.Connector` for instance) are immutable and stateless. They can be safely used from multiple concurrent threads.

Public static methods provided by this class, such as `get(Named)` and `connect(ColorSpace, ColorSpace)`, are also guaranteed to be thread-safe.

See Also:
  - `get(Named)`
  - `ColorSpace.Named`
  - `ColorSpace.Model`
  - `ColorSpace.Connector`
  - `ColorSpace.Adaptation`

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static enum`
  `ColorSpace.Adaptation`
  `static class`
  `ColorSpace.Connector`
  `static enum`
  `ColorSpace.Model`
  A color model is required by a `ColorSpace` to describe the way colors can be represented as tuples of numbers.
  `static enum`
  `ColorSpace.Named`
  List of common, named color spaces.
  `static enum`
  `ColorSpace.RenderIntent`
  A render intent determines how a `connector` maps colors from one color space to another.
  `static class`
  `ColorSpace.Rgb`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final float[]`
  `ILLUMINANT_A`
  Standard CIE 1931 2° illuminant A, encoded in xyY.
  `static final float[]`
  `ILLUMINANT_B`
  Standard CIE 1931 2° illuminant B, encoded in xyY.
  `static final float[]`
  `ILLUMINANT_C`
  Standard CIE 1931 2° illuminant C, encoded in xyY.
  `static final float[]`
  `ILLUMINANT_D50`
  Standard CIE 1931 2° illuminant D50, encoded in xyY.
  `static final float[]`
  `ILLUMINANT_D55`
  Standard CIE 1931 2° illuminant D55, encoded in xyY.
  `static final float[]`
  `ILLUMINANT_D60`
  Standard CIE 1931 2° illuminant D60, encoded in xyY.
  `static final float[]`
  `ILLUMINANT_D65`
  Standard CIE 1931 2° illuminant D65, encoded in xyY.
  `static final float[]`
  `ILLUMINANT_D75`
  Standard CIE 1931 2° illuminant D75, encoded in xyY.
  `static final float[]`
  `ILLUMINANT_E`
  Standard CIE 1931 2° illuminant E, encoded in xyY.
  `static final int`
  `MAX_ID`
  The maximum ID value a color space can have.
  `static final int`
  `MIN_ID`
  The minimum ID value a color space can have.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static ColorSpace`
  `adapt(ColorSpace colorSpace, float[] whitePoint)`
  Performs the chromatic adaptation of a color space from its native white point to the specified white point.
  `static ColorSpace`
  `adapt(ColorSpace colorSpace, float[] whitePoint, ColorSpace.Adaptation adaptation)`
  Performs the chromatic adaptation of a color space from its native white point to the specified white point.
  `static float[]`
  `adaptToIlluminantD50(float[] origWhitePoint, float[] origTransform)`
  Helper method for internal color space transformation.
  `static float[]`
  `cctToXyz(@org.jetbrains.annotations.Range(from=1L, to=2147483647L) int cct)`
  Computes the chromaticity coordinates of a specified correlated color temperature (CCT) on the Planckian locus.
  `static float[]`
  `chromaticAdaptation(ColorSpace.Adaptation adaptation, float[] srcWhitePoint, float[] dstWhitePoint)`
  Computes the chromatic adaptation transform from the specified source white point to the specified destination white point.
  `static ColorSpace.Connector`
  `connect(ColorSpace source)`
  Connects the specified color spaces to sRGB.
  `static ColorSpace.Connector`
  `connect(ColorSpace source, ColorSpace destination)`
  Connects two color spaces to allow conversion from the source color space to the destination color space.
  `static ColorSpace.Connector`
  `connect(ColorSpace source, ColorSpace.RenderIntent intent)`
  Connects the specified color spaces to sRGB.
  `static ColorSpace.Connector`
  `connect(ColorSpace source, ColorSpace destination, ColorSpace.RenderIntent intent)`
  Connects two color spaces to allow conversion from the source color space to the destination color space.
  `boolean`
  `equals(Object o)`
  `abstract float[]`
  `fromXyz(float[] v)`
  Converts tristimulus values from the CIE XYZ space to this color space's color model.
  `float[]`
  `fromXyz(float x, float y, float z)`
  Converts tristimulus values from the CIE XYZ space to this color space's color model.
  `static ColorSpace`
  `get(ColorSpace.Named name)`
  Returns an instance of `ColorSpace` identified by the specified name.
  `@org.jetbrains.annotations.Range(from=1L, to=4L) int`
  `getComponentCount()`
  Returns the number of components that form a color value according to this color space's color model.
  `@org.jetbrains.annotations.Range(from=-1L, to=63L) int`
  `getId()`
  Returns the ID of this color space.
  `abstract float`
  `getMaxValue(@org.jetbrains.annotations.Range(from=0L, to=3L) int component)`
  Returns the maximum valid value for the specified component of this color space's color model.
  `abstract float`
  `getMinValue(@org.jetbrains.annotations.Range(from=0L, to=3L) int component)`
  Returns the minimum valid value for the specified component of this color space's color model.
  `ColorSpace.Model`
  `getModel()`
  Return the color model of this color space.
  `String`
  `getName()`
  Returns the name of this color space.
  `int`
  `hashCode()`
  `boolean`
  `isSrgb()`
  Indicates whether this color space is the sRGB color space or equivalent to the sRGB color space.
  `abstract boolean`
  `isWideGamut()`
  Returns whether this color space is a wide-gamut color space.
  `static ColorSpace`
  `match(float[] toXYZD50, ColorSpace.Rgb.TransferParameters function)`
  Returns a `ColorSpace.Named` instance of `ColorSpace` that matches the specified RGB to CIE XYZ transform and transfer functions.
  `String`
  `toString()`
  Returns a string representation of the object.
  `abstract float[]`
  `toXyz(float[] v)`
  Converts a color value from this color space's model to tristimulus CIE XYZ values.
  `float[]`
  `toXyz(float r, float g, float b)`
  Converts a color value from this color space's model to tristimulus CIE XYZ values.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### ILLUMINANT_A

    public static final float[] ILLUMINANT_A
    Standard CIE 1931 2° illuminant A, encoded in xyY. This illuminant has a color temperature of 2856K.

  - ### ILLUMINANT_B

    public static final float[] ILLUMINANT_B
    Standard CIE 1931 2° illuminant B, encoded in xyY. This illuminant has a color temperature of 4874K.

  - ### ILLUMINANT_C

    public static final float[] ILLUMINANT_C
    Standard CIE 1931 2° illuminant C, encoded in xyY. This illuminant has a color temperature of 6774K.

  - ### ILLUMINANT_D50

    public static final float[] ILLUMINANT_D50
    Standard CIE 1931 2° illuminant D50, encoded in xyY. This illuminant has a color temperature of 5003K. This illuminant is used by the profile connection space in ICC profiles.

  - ### ILLUMINANT_D55

    public static final float[] ILLUMINANT_D55
    Standard CIE 1931 2° illuminant D55, encoded in xyY. This illuminant has a color temperature of 5503K.

  - ### ILLUMINANT_D60

    public static final float[] ILLUMINANT_D60
    Standard CIE 1931 2° illuminant D60, encoded in xyY. This illuminant has a color temperature of 6004K.

  - ### ILLUMINANT_D65

    public static final float[] ILLUMINANT_D65
    Standard CIE 1931 2° illuminant D65, encoded in xyY. This illuminant has a color temperature of 6504K. This illuminant is commonly used in RGB color spaces such as sRGB, BT.209, etc.

  - ### ILLUMINANT_D75

    public static final float[] ILLUMINANT_D75
    Standard CIE 1931 2° illuminant D75, encoded in xyY. This illuminant has a color temperature of 7504K.

  - ### ILLUMINANT_E

    public static final float[] ILLUMINANT_E
    Standard CIE 1931 2° illuminant E, encoded in xyY. This illuminant has a color temperature of 5454K.

  - ### MIN_ID

    public static final int MIN_ID
    The minimum ID value a color space can have.
    See Also:
      - `getId()`
      - Constant Field Values

  - ### MAX_ID

    public static final int MAX_ID
    The maximum ID value a color space can have.
    See Also:
      - `getId()`
      - Constant Field Values

- ## Method Details

  - ### getName

    @Nonnull public String getName()

    Returns the name of this color space. The name is never null and contains always at least 1 character.

    Color space names are recommended to be unique but are not guaranteed to be. There is no defined format but the name usually falls in one of the following categories:

    - Generic names used to identify color spaces in non-RGB color models. For instance: `Generic L*a*b*`.
    - Names tied to a particular specification. For instance: `sRGB IEC61966-2.1` or `SMPTE ST 2065-1:2012 ACES`.
    - Ad-hoc names, often generated procedurally or by the user during a calibration workflow. These names often contain the make and model of the display.

    Because the format of color space names is not defined, it is not recommended to programmatically identify a color space by its name alone. Names can be used as a first approximation.

    It is however perfectly acceptable to display color space names to users in a UI, or in debuggers and logs. When displaying a color space name to the user, it is recommended to add extra information to avoid ambiguities: color model, a representation of the color space's gamut, white point, etc.

    Returns:
      A non-null String of length >= 1

  - ### getId

    public @org.jetbrains.annotations.Range(from=-1L, to=63L) int getId()
    Returns the ID of this color space. Positive IDs match the color spaces enumerated in `ColorSpace.Named`. A negative ID indicates a color space created by calling one of the public constructors.
    Returns:
      An integer between `MIN_ID` and `MAX_ID`

  - ### getModel

    @Nonnull public ColorSpace.Model getModel()
    Return the color model of this color space.
    Returns:
      A non-null `ColorSpace.Model`
    See Also:
      - `ColorSpace.Model`
      - `getComponentCount()`

  - ### getComponentCount

    public @org.jetbrains.annotations.Range(from=1L, to=4L) int getComponentCount()
    Returns the number of components that form a color value according to this color space's color model.
    Returns:
      An integer between 1 and 4
    See Also:
      - `ColorSpace.Model`
      - `getModel()`

  - ### isWideGamut

    public abstract boolean isWideGamut()
    Returns whether this color space is a wide-gamut color space. An RGB color space is wide-gamut if its gamut entirely contains the `sRGB` gamut and if the area of its gamut is 90% of greater than the area of the `NTSC` gamut.
    Returns:
      True if this color space is a wide-gamut color space, false otherwise

  - ### isSrgb

    public boolean isSrgb()

    Indicates whether this color space is the sRGB color space or equivalent to the sRGB color space.

    A color space is considered sRGB if it meets all the following conditions:

    - Its color model is `ColorSpace.Model.RGB`.
    - Its primaries are within 1e-3 of the true `sRGB` primaries.
    - Its white point is within 1e-3 of the CIE standard illuminant `D65`.
    - Its opto-electronic transfer function is not linear.
    - Its electro-optical transfer function is not linear.
    - Its transfer functions yield values within 1e-3 of `ColorSpace.Named.SRGB`.
    - Its range is \([0..1]\).

    This method always returns true for `ColorSpace.Named.SRGB`.

    Returns:
      True if this color space is the sRGB color space (or a close approximation), false otherwise

  - ### getMinValue

    public abstract float getMinValue(@org.jetbrains.annotations.Range(from=0L, to=3L) int component)
    Returns the minimum valid value for the specified component of this color space's color model.
    Parameters:
      `component` - The index of the component
    Returns:
      A floating point value less than `getMaxValue(int)`
    See Also:
      - `getMaxValue(int)`
      - `ColorSpace.Model.getComponentCount()`

  - ### getMaxValue

    public abstract float getMaxValue(@org.jetbrains.annotations.Range(from=0L, to=3L) int component)
    Returns the maximum valid value for the specified component of this color space's color model.
    Parameters:
      `component` - The index of the component
    Returns:
      A floating point value greater than `getMinValue(int)`
    See Also:
      - `getMinValue(int)`
      - `ColorSpace.Model.getComponentCount()`

  - ### toXyz

    @Nonnull @Size(3L) public float[] toXyz(float r, float g, float b)

    Converts a color value from this color space's model to tristimulus CIE XYZ values. If the color model of this color space is not `RGB`, it is assumed that the target CIE XYZ space uses a `D50` standard illuminant.

    This method is a convenience for color spaces with a model of 3 components (`RGB` or `ColorSpace.Model.LAB` for instance). With color spaces using fewer or more components, use `toXyz(float[])` instead

    .
    Parameters:
      `r` - The first component of the value to convert from (typically R in RGB)
      `g` - The second component of the value to convert from (typically G in RGB)
      `b` - The third component of the value to convert from (typically B in RGB)
    Returns:
      A new array of 3 floats, containing tristimulus XYZ values
    See Also:
      - `toXyz(float[])`
      - `fromXyz(float, float, float)`

  - ### toXyz

    @Nonnull @Size(min=3L) public abstract float[] toXyz(@Nonnull @Size(min=3L) float[] v)

    Converts a color value from this color space's model to tristimulus CIE XYZ values. If the color model of this color space is not `RGB`, it is assumed that the target CIE XYZ space uses a `D50` standard illuminant.

    The specified array's length must be at least equal to to the number of color components as returned by `ColorSpace.Model.getComponentCount()`.

    Parameters:
      `v` - An array of color components containing the color space's color value to convert to XYZ, and large enough to hold the resulting tristimulus XYZ values
    Returns:
      The array passed in parameter
    See Also:
      - `toXyz(float, float, float)`
      - `fromXyz(float[])`

  - ### fromXyz

    @Nonnull @Size(min=3L) public float[] fromXyz(float x, float y, float z)

    Converts tristimulus values from the CIE XYZ space to this color space's color model.

    Parameters:
      `x` - The X component of the color value
      `y` - The Y component of the color value
      `z` - The Z component of the color value
    Returns:
      A new array whose size is equal to the number of color components as returned by `ColorSpace.Model.getComponentCount()`
    See Also:
      - `fromXyz(float[])`
      - `toXyz(float, float, float)`

  - ### fromXyz

    @Nonnull @Size(min=3L) public abstract float[] fromXyz(@Nonnull @Size(min=3L) float[] v)

    Converts tristimulus values from the CIE XYZ space to this color space's color model. The resulting value is passed back in the specified array.

    The specified array's length must be at least equal to to the number of color components as returned by `ColorSpace.Model.getComponentCount()`, and its first 3 values must be the XYZ components to convert from.

    Parameters:
      `v` - An array of color components containing the XYZ values to convert from, and large enough to hold the number of components of this color space's model
    Returns:
      The array passed in parameter
    See Also:
      - `fromXyz(float, float, float)`
      - `toXyz(float[])`

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `Object`

  - ### equals

    public boolean equals(Object o)
    Overrides:
      `equals` in class `Object`

  - ### toString

    @Nonnull public String toString()

    Returns a string representation of the object. This method returns a string equal to the value of:

         getName() + "(id=" + getId() + ", model=" + getModel() + ")"

    For instance, the string representation of the `sRGB` color space is equal to the following value:

         sRGB IEC61966-2.1 (id=0, model=RGB)

    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the object

  - ### connect

    @Nonnull public static ColorSpace.Connector connect(@Nonnull ColorSpace source, @Nonnull ColorSpace destination)

    Connects two color spaces to allow conversion from the source color space to the destination color space. If the source and destination color spaces do not have the same profile connection space (CIE XYZ with the same white point), they are chromatically adapted to use the CIE standard illuminant `D50` as needed.

    If the source and destination are the same, an optimized connector is returned to avoid unnecessary computations and loss of precision.

    Colors are mapped from the source color space to the destination color space using the `perceptual` render intent.

    Parameters:
      `source` - The color space to convert colors from
      `destination` - The color space to convert colors to
    Returns:
      A non-null connector between the two specified color spaces
    See Also:
      - `connect(ColorSpace)`
      - `connect(ColorSpace, RenderIntent)`
      - `connect(ColorSpace, ColorSpace, RenderIntent)`

  - ### connect

    @Nonnull public static ColorSpace.Connector connect(@Nonnull ColorSpace source, @Nonnull ColorSpace destination, @Nonnull ColorSpace.RenderIntent intent)

    Connects two color spaces to allow conversion from the source color space to the destination color space. If the source and destination color spaces do not have the same profile connection space (CIE XYZ with the same white point), they are chromatically adapted to use the CIE standard illuminant `D50` as needed.

    If the source and destination are the same, an optimized connector is returned to avoid unnecessary computations and loss of precision.

    Parameters:
      `source` - The color space to convert colors from
      `destination` - The color space to convert colors to
      `intent` - The render intent to map colors from the source to the destination
    Returns:
      A non-null connector between the two specified color spaces
    See Also:
      - `connect(ColorSpace)`
      - `connect(ColorSpace, RenderIntent)`
      - `connect(ColorSpace, ColorSpace)`

  - ### connect

    @Nonnull public static ColorSpace.Connector connect(@Nonnull ColorSpace source)

    Connects the specified color spaces to sRGB. If the source color space does not use CIE XYZ D65 as its profile connection space, the two spaces are chromatically adapted to use the CIE standard illuminant `D50` as needed.

    If the source is the sRGB color space, an optimized connector is returned to avoid unnecessary computations and loss of precision.

    Colors are mapped from the source color space to the destination color space using the `perceptual` render intent.

    Parameters:
      `source` - The color space to convert colors from
    Returns:
      A non-null connector between the specified color space and sRGB
    See Also:
      - `connect(ColorSpace, RenderIntent)`
      - `connect(ColorSpace, ColorSpace)`
      - `connect(ColorSpace, ColorSpace, RenderIntent)`

  - ### connect

    @Nonnull public static ColorSpace.Connector connect(@Nonnull ColorSpace source, @Nonnull ColorSpace.RenderIntent intent)

    Connects the specified color spaces to sRGB. If the source color space does not use CIE XYZ D65 as its profile connection space, the two spaces are chromatically adapted to use the CIE standard illuminant `D50` as needed.

    If the source is the sRGB color space, an optimized connector is returned to avoid unnecessary computations and loss of precision.

    Parameters:
      `source` - The color space to convert colors from
      `intent` - The render intent to map colors from the source to the destination
    Returns:
      A non-null connector between the specified color space and sRGB
    See Also:
      - `connect(ColorSpace)`
      - `connect(ColorSpace, ColorSpace)`
      - `connect(ColorSpace, ColorSpace, RenderIntent)`

  - ### adapt

    @Nonnull public static ColorSpace adapt(@Nonnull ColorSpace colorSpace, @Nonnull @Size(min=2L,max=3L) float[] whitePoint)

    Performs the chromatic adaptation of a color space from its native white point to the specified white point.

    The chromatic adaptation is performed using the `ColorSpace.Adaptation.BRADFORD` matrix.

    The color space returned by this method always has an ID of `MIN_ID`.

    Parameters:
      `colorSpace` - The color space to chromatically adapt
      `whitePoint` - The new white point
    Returns:
      A `ColorSpace` instance with the same name, primaries, transfer functions and range as the specified color space
    See Also:
      - `ColorSpace.Adaptation`
      - `adapt(ColorSpace, float[], Adaptation)`

  - ### adapt

    @Nonnull public static ColorSpace adapt(@Nonnull ColorSpace colorSpace, @Nonnull @Size(min=2L,max=3L) float[] whitePoint, @Nonnull ColorSpace.Adaptation adaptation)

    Performs the chromatic adaptation of a color space from its native white point to the specified white point. If the specified color space does not have an `RGB` color model, or if the color space already has the target white point, the color space is returned unmodified.

    The chromatic adaptation is performed using the von Kries method described in the documentation of `ColorSpace.Adaptation`.

    The color space returned by this method always has an ID of `MIN_ID`.

    Parameters:
      `colorSpace` - The color space to chromatically adapt
      `whitePoint` - The new white point
      `adaptation` - The adaptation matrix
    Returns:
      A new color space if the specified color space has an RGB model and a white point different from the specified white point; the specified color space otherwise
    See Also:
      - `ColorSpace.Adaptation`
      - `adapt(ColorSpace, float[])`

  - ### get

    @Nonnull public static ColorSpace get(@Nonnull ColorSpace.Named name)

    Returns an instance of `ColorSpace` identified by the specified name. The list of names provided in the `ColorSpace.Named` enum gives access to a variety of common RGB color spaces.

    This method always returns the same instance for a given name.

    This method is thread-safe.

    Parameters:
      `name` - The name of the color space to get an instance of
    Returns:
      A non-null `ColorSpace` instance

  - ### match

    @Nullable public static ColorSpace match(@Nonnull @Size(9L) float[] toXYZD50, @Nonnull ColorSpace.Rgb.TransferParameters function)

    Returns a `ColorSpace.Named` instance of `ColorSpace` that matches the specified RGB to CIE XYZ transform and transfer functions. If no instance can be found, this method returns null.

    The color transform matrix is assumed to target the CIE XYZ space a `D50` standard illuminant.

    Parameters:
      `toXYZD50` - 3x3 column-major transform matrix from RGB to the profile connection space CIE XYZ as an array of 9 floats, cannot be null
      `function` - Parameters for the transfer functions
    Returns:
      A non-null `ColorSpace` if a match is found, null otherwise

  - ### adaptToIlluminantD50

    @Nonnull @Size(9L) public static float[] adaptToIlluminantD50(@Nonnull @Size(2L) float[] origWhitePoint, @Nonnull @Size(9L) float[] origTransform)
    Helper method for internal color space transformation.

    This essentially calls adapt on a ColorSpace that has not been fully created. It also does not fully create the adapted ColorSpace, but just returns the transform.

  - ### cctToXyz

    @Nonnull @Size(3L) public static float[] cctToXyz(@org.jetbrains.annotations.Range(from=1L, to=2147483647L) int cct)

    Computes the chromaticity coordinates of a specified correlated color temperature (CCT) on the Planckian locus. The specified CCT must be greater than 0. A meaningful CCT range is [1667, 25000].

    The transform is computed using the methods in Kang et al., Design of Advanced Color - Temperature Control System for HDTV Applications, Journal of Korean Physical Society 41, 865-871 (2002).

    Parameters:
      `cct` - The correlated color temperature, in Kelvin
    Returns:
      Corresponding XYZ values
    Throws:
      `IllegalArgumentException` - If cct is invalid

  - ### chromaticAdaptation

    @Nonnull @Size(9L) public static float[] chromaticAdaptation(@Nonnull ColorSpace.Adaptation adaptation, @Nonnull @Size(min=2L,max=3L) float[] srcWhitePoint, @Nonnull @Size(min=2L,max=3L) float[] dstWhitePoint)

    Computes the chromatic adaptation transform from the specified source white point to the specified destination white point.

    The transform is computed using the von Kries method, described in more details in the documentation of `ColorSpace.Adaptation`. The `ColorSpace.Adaptation` enum provides different matrices that can be used to perform the adaptation.

    Parameters:
      `adaptation` - The adaptation method
      `srcWhitePoint` - The white point to adapt from
      `dstWhitePoint` - The white point to adapt to
    Returns:
      A 3x3 matrix as a non-null array of 9 floats